# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_cipher`](#dsc_cipher): The DSC Cipher resource type. Automatically generated from version 1.0.0
* [`dsc_ciphersuites`](#dsc_ciphersuites): The DSC CipherSuites resource type. Automatically generated from version 1.0.0
* [`dsc_hash`](#dsc_hash): The DSC Hash resource type. Automatically generated from version 1.0.0
* [`dsc_keyexchangealgorithm`](#dsc_keyexchangealgorithm): The DSC KeyExchangeAlgorithm resource type. Automatically generated from version 1.0.0
* [`dsc_protocol`](#dsc_protocol): The DSC Protocol resource type. Automatically generated from version 1.0.0

## Resource types

### <a name="dsc_cipher"></a>`dsc_cipher`

The DSC Cipher resource type.
Automatically generated from version 1.0.0

#### Properties

The following properties are available in the `dsc_cipher` type.

##### `dsc_enabled`

Data type: `Optional[Enum['Yes', 'No']]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Absent', 'Present']]`

 

#### Parameters

The following parameters are available in the `dsc_cipher` type.

* [`dsc_cipher`](#dsc_cipher)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_cipher"></a>`dsc_cipher`

namevar

Data type: `Enum['AES 128/128', 'AES 256/256', 'DES 56/56', 'NULL', 'RC2 128/128', 'RC2 40/128', 'RC2 56/128', 'RC4 128/128', 'RC4 40/128', 'RC4 56/128', 'RC4 64/128', 'Triple DES 168']`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_ciphersuites"></a>`dsc_ciphersuites`

The DSC CipherSuites resource type.
Automatically generated from version 1.0.0

#### Properties

The following properties are available in the `dsc_ciphersuites` type.

##### `dsc_ciphersuitesorder`

Data type: `Array[String]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Absent', 'Present']]`

 

##### `dsc_exists`

Data type: `Optional[Enum['Yes', 'No']]`

 

#### Parameters

The following parameters are available in the `dsc_ciphersuites` type.

* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_hash"></a>`dsc_hash`

The DSC Hash resource type.
Automatically generated from version 1.0.0

#### Properties

The following properties are available in the `dsc_hash` type.

##### `dsc_enabled`

Data type: `Optional[Enum['Yes', 'No']]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Absent', 'Present']]`

 

#### Parameters

The following parameters are available in the `dsc_hash` type.

* [`dsc_hash`](#dsc_hash)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_hash"></a>`dsc_hash`

namevar

Data type: `Enum['MD5', 'SHA', 'SHA256', 'SHA384', 'SHA512']`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_keyexchangealgorithm"></a>`dsc_keyexchangealgorithm`

The DSC KeyExchangeAlgorithm resource type.
Automatically generated from version 1.0.0

#### Properties

The following properties are available in the `dsc_keyexchangealgorithm` type.

##### `dsc_enabled`

Data type: `Optional[Enum['Yes', 'No']]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Absent', 'Present']]`

 

#### Parameters

The following parameters are available in the `dsc_keyexchangealgorithm` type.

* [`dsc_keyexchangealgorithm`](#dsc_keyexchangealgorithm)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_keyexchangealgorithm"></a>`dsc_keyexchangealgorithm`

namevar

Data type: `Enum['Diffie-Hellman', 'ECDH', 'PKCS']`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_protocol"></a>`dsc_protocol`

The DSC Protocol resource type.
Automatically generated from version 1.0.0

#### Properties

The following properties are available in the `dsc_protocol` type.

##### `dsc_enabled`

Data type: `Optional[Enum['Yes', 'No']]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Absent', 'Present']]`

 

#### Parameters

The following parameters are available in the `dsc_protocol` type.

* [`dsc_protocol`](#dsc_protocol)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_type`](#dsc_type)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_protocol"></a>`dsc_protocol`

namevar

Data type: `Enum['Multi-Protocol Unified Hello', 'PCT 1.0', 'SSL 2.0', 'SSL 3.0', 'TLS 1.0', 'TLS 1.1', 'TLS 1.2']`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_type"></a>`dsc_type`

namevar

Data type: `Enum['Client', 'Server']`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

